<?php
/*
  $Id: ht_hide_boxes.php
  $Loc: catalog/includes/modules/header_tags/

  osCommerce, Open Source E-Commerce Solutions
  http://www.oscommerce.com

  Hide Boxes 1.1
  by @raiwa 
  info@oscaddons.com
  www.oscaddons.com

  Copyright (c) 2020 Rainer Schmied

  Released under GNU License
*/

  class ht_hide_boxes extends abstract_executable_module {

    const CONFIG_KEY_BASE = 'MODULE_HEADER_TAGS_HIDE_BOXES_';

    public function __construct() {
      parent::__construct(__FILE__);

    }

    function execute() {
        
      if (tep_not_null(MODULE_HEADER_TAGS_HIDE_BOXES_BOXES)) {
        $boxes_array = explode(';', MODULE_HEADER_TAGS_HIDE_BOXES_BOXES);
        $script = null;
        foreach ($boxes_array as $box) {
          $box = str_replace('_', '-', $box);
          $script .= <<<EOD
var element = document.getElementsByClassName('{$box}')[0];
if (element) {
  element.classList.add('d-none','d-md-block');
}
EOD
 . PHP_EOL;
        }
        
        $GLOBALS['oscTemplate']->addBlock('<script>' . PHP_EOL . $script . '</script>' . PHP_EOL, 'footer_scripts');
      }
    }

    protected function get_parameters() {
      return [
        'MODULE_HEADER_TAGS_HIDE_BOXES_STATUS' => [
          'title' => 'Hide Boxes',
          'value' => 'True',
          'desc' => 'Do you want to add HIde Boxes to your shop?',
          'set_func' => "tep_cfg_select_option(['True', 'False'], ",
        ],
        'MODULE_HEADER_TAGS_HIDE_BOXES_BOXES' => [
          'title' => 'Boxes',
          'value' => '',
          'desc' => 'Tick the boxes to hide on mobile.',
          'set_func' => 'ht_hide_boxes_edit_boxes(',
          'use_func' => 'ht_hide_boxes_show_boxes',
        ],
        'MODULE_HEADER_TAGS_HIDE_BOXES_SORT_ORDER' => [
          'title' => 'Sort Order',
          'value' => '1000',
          'desc' => 'Sort order of display. Lowest is displayed first.',
        ],
      ];
    }
    
  } // end class

  function ht_hide_boxes_show_boxes($text) {
    return nl2br(implode("\n", explode(';', $text)));
  }

  function ht_hide_boxes_edit_boxes($values, $key) {

    $inst_array = str_replace('.php', '', explode(';', MODULE_BOXES_INSTALLED));  

    sort($inst_array);

    $values_array = explode(';', $values);

    $output = '';
    foreach ($inst_array as $file) {
      $output .= tep_draw_checkbox_field('ht_hide_boxes_file[]', $file, in_array($file, $values_array)) . '&nbsp;' . tep_output_string($file) . '<br />';
    }

    if (!empty($output)) {
      $output = '<br />' . substr($output, 0, -6);
    }

    $output .= tep_draw_hidden_field('configuration[' . $key . ']', '', 'id="htrn_files"');

    $output .= '<script>
                function htrn_update_cfg_value() {
                  var htrn_selected_files = \'\';

                  if ($(\'input[name="ht_hide_boxes_file[]"]\').length > 0) {
                    $(\'input[name="ht_hide_boxes_file[]"]:checked\').each(function() {
                      htrn_selected_files += $(this).attr(\'value\') + \';\';
                    });

                    if (htrn_selected_files.length > 0) {
                      htrn_selected_files = htrn_selected_files.substring(0, htrn_selected_files.length - 1);
                    }
                  }

                  $(\'#htrn_files\').val(htrn_selected_files);
                }

                $(function() {
                  htrn_update_cfg_value();

                  if ($(\'input[name="ht_hide_boxes_file[]"]\').length > 0) {
                    $(\'input[name="ht_hide_boxes_file[]"]\').change(function() {
                      htrn_update_cfg_value();
                    });
                  }
                });
                </script>';

    return $output;
  }
